<?php

chdir('../../');

include("./include/auth.php");
include_once("./lib/snmp.php");
include_once("./lib/utility.php");

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

if (isset($_POST['host']))
	$host = $_POST['host'];
else
	$host = '127.0.0.1';

include_once("./include/top_header.php");

show_tools ();

switch ($action) {
	case 'servicecheck': 
		ShowServiceCheck();
		break;
	case 'snmpwalk': 
		WalkHost();
		break;
	case 'healthcheck':
		ShowHealthCheck();
		break;
	case 'edit':

		break;
	case 'delete':

		break;
	default:
		break;
}

include_once("./include/bottom_footer.php");


function show_tools () {
	global $action, $host;
	print "<br><br><br><center>";
print "<div align='left'>";
	print "<table bgcolor=black cellpadding=1 cellspacing=0><tr><td>
	<table width='100%' bgcolor=white cellspacing=3><tr><td>";
	print "<form method=POST action=tools.php>";
	print "<table width='100%'><tr><td valign=center width=50>Host</td><td valign=center>";
	print "<input type=text size=20 value='$host' name=host id=host><br><br></center></td></tr>";
	print "<tr><td colspan=2><hr width='100%'></td></tr>";
//SNMP Walk
	print "<tr><td><input type=radio name=action value=snmpwalk";
	if ($action == 'snmpwalk')
		print " checked";
	print "></td><td><h3>SNMP Walk</h3>";
	print "<table cellspacing=0 cellpadding=0 corder=0><tr><td>OID</td><td><input type=text size=20 value='.1' name=oid id=oid></td></tr>";
	print "<tr><td>Community&nbsp;&nbsp;&nbsp;</td><td><input type=text size=20 value='public' name=community id=community></td></tr></table>";
	print "</td><tr>";
	print "<tr><td colspan=2><hr width='100%'></td></tr>";

// Service Check
	print "<tr><td><input type=radio name=action value=servicecheck";
	if ($action == 'servicecheck')
		print " checked";
	print "></td><td><h3>Service Check</h3><input type=checkbox name=http checked>HTTP<input type=checkbox name=ftp checked>FTP<input type=checkbox name=pop3 checked>POP3<input type=checkbox name=smtp checked>SMTP</td><tr>";
//Port check
	print "<tr><td colspan=2><hr width='100%'></td></tr>";
	if (isset($_POST['porttocheck']))
		$porttocheck = $_POST['porttocheck'];
	else
		$porttocheck = "";
	if (isset($_POST['parameter']))
		$parameter = $_POST['parameter'];
	else
		$parameter = "";
	print "<tr><td><input type=radio name=action value=healthcheck";
	if ($action == 'healthcheck')
		print " checked";
	print ">";
	print "</td><td><h3>Http health check</h3>";
	print "<table cellspacing=0 cellpadding=0 corder=0>";
	print "<tr><td>port to check&nbsp;&nbsp;&nbsp;</td>";
	print "<td><input type=text size=20 value='".$porttocheck."' name=porttocheck id=porttocheck></td></tr>";
	print "<tr><td>path to check&nbsp;&nbsp;&nbsp;</td>";
	print "<td><input type=text size=50 value='".$parameter."' name=parameter id=parameter></td></tr>";
	print "<tr><td></td><td> ex: /linktocheck (when you want check http://myserver:port/linktocheck)<br>  ex: /nsi/servlet/nsi.serveur.managertechnique.servlet.Tech_ListeSessions</td></tr>";
	print "</table>";
//
	print "<tr><td colspan=2><hr width='100%'></td></tr>";
	print "<tr><td></td><td><input type=submit value=Submit></td></tr>";
	print "</table></form>";
	print "</td></tr></table></td></tr></table>";
print "</div>";
}


function ShowServiceCheck () {

	if (isset($_POST['host']))
		$host = $_POST['host'];
	else
		return;
//	print "<br><br><br><center><table width=500 bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white><tr><td>";
	print "<br><br><br><center><table bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white><tr><td>";
		$results = array();
	$results[] = ServiceCheck($host, 'http');
	$results[] = ServiceCheck($host, 'ftp');
	$results[] = ServiceCheck($host, 'pop3');
	$results[] = ServiceCheck($host, 'smtp');

	print "<center><table><tr><td colspan=5><center><h3>Service Results for $host</h3></center></td></tr><tr><td></td><td><b><u>Service</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Port</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Result</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><b><u>Time</u></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>";
	foreach ($results as $r) {
		print "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>" . $r['service'] . "</td><td>" . $r['port'] . "</td><td>" . $r['result'] . "</td><td>" . $r['time'] . "</td></tr>";
	}
	print "</table></center>";
	print "</td></tr></table></td></tr></table>";

}

function ShowHealthCheck () {

	if (isset($_POST['host']))
		$host = $_POST['host'];
	else
		return;
	if (isset($_POST['porttocheck']))
		$porttocheck = $_POST['porttocheck'];
	else
		$porttocheck = "";
	if (isset($_POST['parameter']))
		{ $req = $_POST['parameter']; $req = preg_replace('/\\\\/', '\\', $req); }
	else
		$req = "";
	if ($porttocheck=="") exit;
	print "<br>";
	print "<div align='left'>";
	print "<table bgcolor=black cellpadding=1 cellspacing=0>";
	print "<tr><td><table width='100%' bgcolor=white><tr><td>";

	print "<center><table><tr><td colspan=2>
		<center><h3>Port check Results for $host</h3></center></td></tr>";
	$results = array();
	$results[] = HealthCheck($host, $porttocheck, $req);
	$r=$results[0];

	print "<tr><td>host=" . $r['host'] . "</td><td></td></tr>";
	print "<tr><td>host=" . $r['port'] . "</td><td></td></tr>";
	print "<tr><td>request=</td><td>" . $r['request'] . "</td></tr>";
	print "<tr><td>" . $r['result'] . "</td><td>" . $r['time'] . "</td></tr>";
	print "<tr><td>" . "error msg" . "</td><td>" . $r['error'] . "</td></tr>";

	print "</table></center>";
	print "</td></tr></table></td></tr></table>";
	print "</div>";
}

function HealthCheck($host, $port, $req, $timeout = 10) {
	$host = strtolower($host);
	$req = preg_replace('/\\\\/', '\\', $req);
	$Request ="HEAD " . $req . " HTTP/1.0\r\nUser-Agent: Service Check\r\nHost: $host\r\n\r\n";
	$OkResults = array("200\D+OK", "200\D+Document\s+Follows", "302", "301");
	if(!is_numeric($port)) $port = 80;

	list($MSec, $Sec) = explode(" ", microtime());
	$TimeBegin = (double) $MSec + (double) $Sec;
	$Socket = @fsockopen($host, $port, $error_number, $error, $timeout);
	list($MSec, $Sec) = explode(" ", microtime());
	$TimeEnd = (double) $MSec + (double) $Sec;
	$Time = number_format($TimeEnd - $TimeBegin, 3);
	// Check port

	if (is_resource($Socket)) {
		if ($Request != "") {
			fputs($Socket, $Request);
			stream_set_timeout($Socket, $timeout);
		}
		if (!feof($Socket)) {
			$Response = fgets($Socket, 4096);
			stream_set_timeout($Socket, $timeout);
		}
		$Result = "Failed";
		$Error  = $Response;

		foreach($OkResults as $exp_result) {
			if (preg_match("/$exp_result/",$Response)) {
				$Error = "";
				$Result = "Ok";
			}
		}
		fclose($Socket);
	 } else { 
		$Result = "Failed";
		$Error = ((!$error) ? "Time out" : $error);
	 }

	 return array(
			'host'   => $host,
			'port'   => $port,
			'request'=> $Request,
			'result' => $Result,
			'time'   => $Time,
			'error'  => $Error
		 );

}

function IsValidHost($host) {
	if(preg_match("/^((([0-9]{1,3}\.){3}[0-9]{1,3})|([0-9a-z-.]{0,61})?\.[a-z]{2,4})$/i", $host)) 
		return 1;
	return 0;
}

function WalkHost () {
	global $config;
	if (isset($_POST['host']))
		$host = $_POST['host'];		
	else
		return;
	if (isset($_POST['oid']))
		$oid = $_POST['oid'];
	else
		$oid = ".1";
	if (isset($_POST['community']))
		$community = $_POST['community'];
	else
		$community = "public";

	$host = strtolower($host);
	snmp_set_quick_print(0);

	$a = cacti_snmp_walk($host, $community, $oid, 2, "", "", 161, 1000);
	print "<br><br><br><center><table bgcolor=black cellpadding=1 cellspacing=0><tr><td><table width='100%' bgcolor=white><tr><td>";

	print "<center><table border=1px><tr><td colspan=2 bgcolor=white><center><h3>SNMP Walk Results for $host</h3></center></td></tr>";
	foreach ($a as $val) {
		print "<tr><td>" . $val['oid'] . "</td><td>" . $val['value'] . "</td></tr>";
	}
	print "</table></center>";
	print "</td></tr></table></td></tr></table>";
}


function ServiceCheck($host, $service, $port='', $timeout = 10) {
	$host = strtolower($host);

	switch($service) {
		case 'http': 
			$Request = "HEAD / HTTP/1.0\r\nUser-Agent: Service Check\r\nHost: $host\r\n\r\n";
			$OkResults = array("200\D+OK", "200\D+Document\s+Follows", "302", "301");
			if(!is_numeric($port)) $port = 80;
			break;

		case 'ftp': 
			$OkResults = array("220");
			$Request = '';
			if(!is_numeric($port)) $port = 21;
			break;
	
		case 'smtp': 
			$OkResults = array("220");
			$Request = '';
			if(!is_numeric($port)) $port = 25;
			break;

		case 'pop3': 
			$OkResults = array("\\+OK");
			$Request = '';
			if(!is_numeric($port)) $port = 110;
			break;
	}

	list($MSec, $Sec) = explode(" ", microtime());
	$TimeBegin = (double) $MSec + (double) $Sec;
	$Socket = @fsockopen($host, $port, $error_number, $error, $timeout);

	list($MSec, $Sec) = explode(" ", microtime());
	$TimeEnd = (double) $MSec + (double) $Sec;
	$Time = number_format($TimeEnd - $TimeBegin, 3);
	// Check port

	if (is_resource($Socket)) {
		if ($Request != "") {
			fputs($Socket, $Request);
			stream_set_timeout($Socket, $timeout);
		}
		if (!feof($Socket)) {
			$Response = fgets($Socket, 4096);
			stream_set_timeout($Socket, $timeout);
		}
		$Result = "Failed";
		$Error  = $Response;

		foreach($OkResults as $exp_result) {
			if (preg_match("/$exp_result/",$Response)) {
				$Error = "";
				$Result = "Ok";
			}
		}
		fclose($Socket);
	 } else { 
		$Result = "Failed";
		$Error = ((!$error) ? "Time out" : $error);
	 }

	 return array(
			'host'   => $host,
			'service'=> $service,
			'port'   => $port,
			'result' => $Result,
			'time'   => $Time,
			'error'  => $Error
		 );

}


?>
